#!/usr/bin/python3

"""
$Id: directory_tree.py 766 2018-05-29 10:49:26Z heijer $
$Date: 2018-05-29 12:49:26 +0200 (di, 29 mei 2018) $
$Author: heijer $
$Revision: 766 $
$HeadURL: https://repos.deltares.nl/repos/kustgenese2/trunk/datamanagement/datamanagementplan/contrib/directory_tree.py $
"""

import os
import re


def listdirs(url='https://svn.citg.tudelft.nl/sandbox/trunk/'):
    os.system('svn ls "%s" > list.txt' % url)
    with open('list.txt') as fobj:
        txt = fobj.read()
    lst = [d for d in txt.split('\n') if d != '']
    dirs = [d for d in lst if d.endswith('/')]
    files = [d for d in lst if not d.endswith('/')]
    return dirs, files

def createtree(url='https://svn.citg.tudelft.nl/sandbox/trunk/', path='', level=0, recursive=True, maxdepth=None, files=False, s=''):
    fullurl = os.path.join(url, path)
    dirs, lst = listdirs(url=fullurl)
    if files:
        dirs = dirs + lst
    if fullurl.endswith('/'):
        href = (fullurl.split('/')[-2] + '/').replace('_', '\_')
    else:
        href = fullurl.split('/')[-1].replace('_', '\_')

#     if '_' not in href:
    
    href = '\href{%s}{%s}' % (fullurl, href)
    s = '%s\n%s[%s' % (s, ' '*level, href)
    for d in dirs:
        if fullurl.endswith('standard/') or maxdepth is not None and level>=maxdepth:
            continue
        if recursive:
            s = createtree(url=fullurl, path=d, level=level+1, recursive=True, maxdepth=maxdepth, s=s)
    s = '%s%s]' % (s, ' '*level)
    return s


destdir = os.path.join(os.path.dirname(__file__), '..', 'annexes', 'directory_structure', 'contents')
with open(os.path.join(os.path.dirname(__file__), 'dataset.tex')) as tmpl:
    txt = tmpl.read()

destfile = os.path.join(destdir, 'dataset.tex')
with open(destfile, 'w') as fobj:
    fobj.write(txt)

s = createtree(maxdepth=2, files=True)
re_dataset = re.compile('\s+\[<dataset>.*\]', re.DOTALL)
txt_trunk = re_dataset.sub(s, txt)
destfile = os.path.join(destdir, 'trunk.tex')
with open(destfile, 'w') as fobj:
    fobj.write(txt_trunk)

for d in listdirs()[0]:
#   if d in ('datamanagement/'):
#        continue
    s = createtree(path=d,maxdepth=2)
    tree = re_dataset.sub(s, txt)
    destfile = os.path.join(destdir, d.replace('/', '.tex'))
    with open(destfile, 'w') as fobj:
        fobj.write(tree)

